#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.16.1
 Author:         myName

 Script Function:
	Template AutoIt script.

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here
global $sConnectionString

#cs
Func _connexion_MySQL()
	; Link to Windows MySQL ODBC drivers
	; https://dev.mysql.com/downloads/connector/odbc/

	Local $sDriver = 'MySQL ODBC 8.2 ANSI Driver' ; 'MySQL ODBC 5.3 UNICODE Driver'
	Local $sServer = 'ip' ; change this string to YourServerLocation
	Local $sDatabase = 'DB' ; change this string to YourDatabaseName
	Local $sPort = '3306' ; change this string to If your Server use non standard PORT
	Local $sUser = 'base' ; change this string to YourUserName
	Local $sPassword = 'password' ; change this string to YourPassword


	global $sConnectionString = _ADO_ConnectionString_MySQL($sUser, $sPassword, $sDatabase, $sDriver, $sServer, $sPort)



;~ 	_Example_2_RecordsetDisplay($sConnectionString, "INSERT INTO `clients` (`id`, `nom`, `prenom`, `adresse1`, `adresse2`, `cp`, `ville`, `pays`, `telephone`, `portable`, `mail`) VALUES (NULL, 'PERON', 'Fabien', '342 route de Kerbris', '', '29300', 'BAYE', 'France', '060600606', '0670528725', 'p-fabien@live.fr');")
;~  _Example_2_RecordsetDisplay($sConnectionString, "SELECT * FROM clients WHERE `nom` LIKE '%per%'")


EndFunc

#ce



Func _sStrFrAccentRemove($sString)
	;&========================================================================================================================
	;& Description....: Convert characters with accent to a fom without accent based on french language
	;& Parameter(s)...:
	;&					$sString to convert
	;& Return value(s)
	;&		Function..: String converted
	;&		Error(s)..:	-
	;& -
	;& Versions.......: 1.0.0
	;& -
	;& Author(s)......: Jean-Pol Dekimpe (Jeep)
	;& Date...........: 2019/01/01
	;& Language.......: English
	;& AutoIt.........: v3.3.14.5
	;& -
	;& Remark(s)......: Conversion is based on french language
	;&========================================================================================================================
	Local $sFrom = "àáâãäåæçèéêëìíîïòóôöùúûüýÿœ", $sChar = "", $sOutString = ""
	Local $aTo = ["a", "a", "a", "a", "a", "a", "ae", "c", "e", "e", "e", "e", "i", "i", "i", "i", "o", "o", "o", "o", _
			"u", "u", "u", "u", "y", "y", "oe"]
	Local $aChars = StringSplit($sString, "")
	Local $iPos = 0

	For $i = 1 To $aChars[0]
		$sChar = $aChars[$i]
		$iPos = StringInStr($sFrom, $sChar)
		If $iPos = 0 Then
			$sOutString &= $sChar
		Else
			If StringIsUpper($sChar) Then
				$sOutString &= StringUpper($aTo[$iPos])
			Else
				$sOutString &= $aTo[$iPos]
			EndIf
		EndIf
	Next
	Return $sOutString
EndFunc   ;==>_sStrFrAccentRemove

Func _sStrTitleCase($sString, $sLanguage = "FR")
	;&========================================================================================================================
	;& Description....: Uppercase first letter of each word + support a French context
	;&					No uppercase after "'"
	;& Parameter(s)...:
	;&					$sString - string of characters to convert
	;&					$sLanguage = "FR" like French to process accent characters; They are removed before converting to
	;&                               uppercase
	;& Return value(s)
	;&		Function..: resulting string
	;&		Error(s)..: -
	;& -
	;& Versions.......: 1.0.0
	;& -
	;& Author(s)......: Jean-Pol Dekimpe (Jeep)
	;& Date...........: 2019/01/01
	;& Language.......: English
	;& AutoIt.........: v3.3.14.5
	;& -
	;& Remarks........: -
	;&========================================================================================================================
	Local $bCapNext = True
	Local $sChr = "", $sReturn = ""
	Local $aChars = StringSplit($sString, "")

	For $i = 1 To $aChars[0]
		$sChr = $aChars[$i]
		Select
			Case $bCapNext = True
				If StringRegExp($sChr, "[a-zA-Z\xC0-\xFF0-9]") Then
					If $sLanguage = "FR" Then $sChr = (_sStrFrAccentRemove($sChr))
					$sChr = StringUpper($sChr)
					$bCapNext = False
				EndIf
			Case ($sLanguage <> "FR" And Not StringRegExp($sChr, "[a-zA-Z\xC0-\xFF'0-9]")) Or _
					(Not StringRegExp($sChr, "(*UCP)[a-zA-Z\xC0-\xFF0-9'’]"))
				$bCapNext = True
			Case Else
				$sChr = StringLower($sChr)
		EndSelect
		$sReturn &= $sChr
	Next
	Return $sReturn
EndFunc   ;==>_sStrTitleCase





